#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    int niz[n];

    vector<vector<int>> par(n);

    for(int i = 0; i < n; i++)
    {
        cin >> niz[i];

        for(int j = 0; j <= i; j++)
        {
            if((niz[i] & niz[j]) > (niz[i] ^ niz[j]))
            {
                par[i].push_back(j);
                //par[j].push_back(i);
            }
        }
    }

    for(int i = 0; i < q; i++)
    {
        int l, r;
        int brojac = 0;

        cin >> l >> r;
        l--;
        r--;
        int maks = 0;
        int index = 0;

        for(int j = l; j <= r; j++)
        {
            brojac = 0;

            for(int a : par[j])
            {
                if(a >= l && a <= r)
                {
                    brojac++;
                }
            }

            if(brojac > maks)
            {
                maks = brojac;
                index = j;
            }
        }

        cout << maks << endl;
    }

    return 0;
}